diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
index dc19908f4..1b00dd329 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMap.java
@@ -6,7 +6,7 @@ import it.unimi.dsi.fastutil.ints.Int2ObjectMap;
 import it.unimi.dsi.fastutil.ints.Int2ObjectOpenHashMap;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlag;
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
@@ -19,6 +19,7 @@ import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.world.pos.ChunkTilePos;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import net.minecraft.core.world.saveddata.maps.ItemMapSavedData;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -124,7 +125,7 @@ public class ItemMap extends Item implements IComplexItem
 	}
 
 	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
 		if (world.getBlockId(blockPos) == Blocks.FLAG.id()) {
 			if (hasInitialized(selfStack)) {
 				for (byte scale = 0; scale <= ItemMapSavedData.MAX_SCALE; scale++) {
@@ -231,11 +232,11 @@ public class ItemMap extends Item implements IComplexItem
 										height--;
 									}
 								} while (runLoop);
-								if(Blocks.blocksList[id].getMaterial() == Material.water) {
+								if(Blocks.blocksList[id].getMaterial() == Materials.WATER) {
 									int _y = height;
                                     int _blockID = chunk.getBlockId(tempChunkPos.set(_x + blockInChunkX, _y--, _z + blockInChunkZ));
                                     waterDepth++;
-                                    while (_y > 0 && _blockID > 0 && Blocks.blocksList[_blockID].getMaterial() == Material.water) {
+                                    while (_y > 0 && _blockID > 0 && Blocks.blocksList[_blockID].getMaterial() == Materials.WATER) {
                                         _blockID = chunk.getBlockId(tempChunkPos.set(_x + blockInChunkX, _y--, _z + blockInChunkZ));
                                         waterDepth++;
                                     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
index 0059bf52d..0b0898cc4 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemMinecart.java
@@ -11,6 +11,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -25,12 +26,12 @@ public class ItemMinecart extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         Block<?> block = world.getBlock(blockPos);
         if (!Block.hasLogicClass(block, BlockLogicRail.class)) { return false; }
 
         if(!world.isClientSide) {
-            world.entityJoinedWorld(new EntityMinecart(world, (float) blockPos.x + 0.5F, (float) blockPos.y + 0.5F, (float) blockPos.z + 0.5F, this.minecartType));
+            world.entityJoinedWorld(new EntityMinecart(world, (float) blockPos.x() + 0.5F, (float) blockPos.y() + 0.5F, (float) blockPos.z() + 0.5F, this.minecartType));
         }
         if (player == null || player.getGamemode().consumeBlocks()) {
             selfStack.stackSize--;
@@ -39,7 +40,7 @@ public class ItemMinecart extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        onUseOnBlock(selfStack, world, null, blockPos.add(direction), direction.getSide(), 0.5, 0.5);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        onUseOnBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide(), 0.5, 0.5);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
index 995d2e7be..881ceeb67 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPaintBrush.java
@@ -16,11 +16,13 @@ import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
@@ -35,7 +37,7 @@ public class ItemPaintBrush extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         final int id = world.getBlockId(blockPos);
         final Block<?> block = Blocks.getBlock(id);
 
@@ -50,7 +52,7 @@ public class ItemPaintBrush extends Item {
             if (!paintable.canBePainted()) return false;
             final DyeColor color = getColor(selfStack);
             if (color != null) {
-                if (paintable instanceof IPainted && ((IPainted)paintable).getColor(world, blockPos) == color) {
+                if (paintable instanceof IPainted && ((IPainted) paintable).getColor(world, blockPos) == color) {
                     return false;
                 }
                 paintable.setColor(world, blockPos, color);
@@ -63,15 +65,15 @@ public class ItemPaintBrush extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
         if (!onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5)) {
-            AABB box = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1, blockPos.y + 1, blockPos.z + 1);
+            AABBdc box = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1, blockPos.y() + 1, blockPos.z() + 1);
             List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
             if (!entities.isEmpty()) {
                 MobSheep sheep = entities.get(0);
                 DyeColor woolColor = getColor(selfStack);
-                if(woolColor != null && sheep.getFleeceColor() != woolColor) {
+                if (woolColor != null && sheep.getFleeceColor() != woolColor) {
                     sheep.setFleeceColor(woolColor);
                     consumePaint(selfStack, null);
                 }
@@ -90,9 +92,9 @@ public class ItemPaintBrush extends Item {
 
     @Override
     public boolean useOnEntity(@NotNull ItemStack selfStack, @NotNull Player player, @NotNull Mob mob) {
-        if(mob instanceof MobSheep mobSheep) {
+        if (mob instanceof MobSheep mobSheep) {
             DyeColor woolColor = getColor(selfStack);
-            if(woolColor != null && mobSheep.getFleeceColor() != woolColor) {
+            if (woolColor != null && mobSheep.getFleeceColor() != woolColor) {
                 mobSheep.setFleeceColor(woolColor);
                 consumePaint(selfStack, player);
                 return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java b/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
index dc56b1f5b..dfd7bfdfa 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPainting.java
@@ -6,14 +6,13 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class ItemPainting extends Item {
 
-    public ItemPainting(@NotNull String name, @NotNull String namespaceId, int id)
-    {
+    public ItemPainting(@NotNull String name, @NotNull String namespaceId, int id) {
         super(name, namespaceId, id);
     }
 
@@ -26,7 +25,7 @@ public class ItemPainting extends Item {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (side.isVertical() || player == null) return false;
         int direction = switch (side) {
             case NORTH -> 0;
@@ -35,12 +34,12 @@ public class ItemPainting extends Item {
             case EAST -> 3;
             default -> 0;
         };
-        EntityPainting entity = new EntityPainting(world, blockPos.x, blockPos.y, blockPos.z, direction, player.getSelectedArt().key);
-        if(entity.canStay()) {
-            if(!world.isClientSide) {
+        EntityPainting entity = new EntityPainting(world, blockPos.x(), blockPos.y(), blockPos.z(), direction, player.getSelectedArt().key);
+        if (entity.canStay()) {
+            if (!world.isClientSide) {
                 world.entityJoinedWorld(entity);
             }
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.PLANKS_OAK, EnumBlockSoundEffectType.PLACE);
             selfStack.consumeItem(player);
             return true;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
index 9be945ce1..e66293138 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPebble.java
@@ -8,11 +8,13 @@ import net.minecraft.core.entity.projectile.ProjectilePebble;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.Random;
 
@@ -27,14 +29,14 @@ public class ItemPebble extends Item implements IDispensable {
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
         selfStack.consumeItem(player);
         world.playSoundAtEntity(player, player, "random.bow", 0.5F, 0.4F / (itemRand.nextFloat() * 0.4F + 0.8F));
-        if(!world.isClientSide) {
+        if (!world.isClientSide) {
             world.entityJoinedWorld(new ProjectilePebble(world, player));
         }
         return selfStack;
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         if (player == null) return false;
         int id = world.getBlockId(blockPos);
         int meta = world.getBlockData(blockPos);
@@ -45,20 +47,20 @@ public class ItemPebble extends Item implements IDispensable {
         if (selfStack.stackSize <= 0) {
             return false;
         }
-        if (blockPos.y == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.getMaterial().isSolid()) {
+        if (blockPos.y() == world.getHeightBlocks() - 1 && Blocks.OVERLAY_PEBBLES.getMaterial().isSolid()) {
             return false;
         }
 
         // Check if we're placing "inside" a layer
         if (id == Blocks.OVERLAY_PEBBLES.id() && side == Side.TOP) {
             final int newMeta = meta + 1;
-            if (!world.canPlaceOnSurfaceOfBlock(blockPos.down())) {
+            if (!world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
                 return false;
             }
 
             if (newMeta < 3) {
                 world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), newMeta);
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
@@ -68,7 +70,7 @@ public class ItemPebble extends Item implements IDispensable {
 
         // Offset position
         if (id != 0) {
-            blockPos = blockPos.add(side.getDirection());
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
             id = world.getBlockId(blockPos);
             meta = world.getBlockData(blockPos);
         }
@@ -77,14 +79,14 @@ public class ItemPebble extends Item implements IDispensable {
         if (id == Blocks.OVERLAY_PEBBLES.id()) {
             final int newMeta = meta + 1;
 
-            final AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + (2 * (newMeta + 1)) / 16.0f, blockPos.z + 1f);
-            if (!world.checkIfAABBIsClear(bbBox) || !world.canPlaceOnSurfaceOfBlock(blockPos.down())) {
+            final AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + (2 * (newMeta + 1)) / 16.0f, blockPos.z() + 1f);
+            if (!world.checkIfAABBIsClear(bbBox) || !world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
                 return false;
             }
 
             if (newMeta < 3) {
                 world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), newMeta);
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
@@ -92,10 +94,10 @@ public class ItemPebble extends Item implements IDispensable {
         }
 
         // Regular placement, as all else fails
-        if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && world.canPlaceOnSurfaceOfBlock(blockPos.down())) {
+        if (world.canBlockIdBePlacedAt(Blocks.OVERLAY_PEBBLES.id(), blockPos, false, side) && world.canPlaceOnSurfaceOfBlock(blockPos.down(new TilePos()))) {
             if (world.setBlockIdDataNotify(blockPos, Blocks.OVERLAY_PEBBLES.id(), 0)) {
                 Blocks.OVERLAY_PEBBLES.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.OVERLAY_PEBBLES, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
@@ -104,8 +106,8 @@ public class ItemPebble extends Item implements IDispensable {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        ProjectilePebble projectilePebble = new ProjectilePebble(world, blockPos.x + offX, blockPos.y + offY, blockPos.z + offZ);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        ProjectilePebble projectilePebble = new ProjectilePebble(world, blockPos.x() + offX, blockPos.y() + offY, blockPos.z() + offZ);
         projectilePebble.setHeading(direction.getOffsetX() * 0.6, direction.getOffsetY() == 0 ? 0.1 : direction.getOffsetY() * 0.6, direction.getOffsetZ() * 0.6f, 1.1F, 6F);
         world.entityJoinedWorld(projectilePebble);
         selfStack.stackSize -= 1;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
index f887baf03..212e44032 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemPlaceable.java
@@ -10,58 +10,59 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class ItemPlaceable extends Item {
-	
-	public final @NotNull Block<?> blockToPlace;
-	
-	public ItemPlaceable(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> blockToPlace) {
-		super(name, namespaceId, id);
-		
-		this.blockToPlace = blockToPlace;
-	}
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		if(selfStack.stackSize <= 0) {
-			return false;
-		}
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(side.getDirection());
-		}
-		if(blockPos.y < 0 || blockPos.y >= world.getHeightBlocks()) {
-			return false;
-		}
-		if(world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-			if(world.setBlockIdNotify(blockPos, this.blockToPlace.id())) {
-				if (player == null) {
+    public final @NotNull Block<?> blockToPlace;
+
+    public ItemPlaceable(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<?> blockToPlace) {
+        super(name, namespaceId, id);
+
+        this.blockToPlace = blockToPlace;
+    }
+
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (selfStack.stackSize <= 0) {
+            return false;
+        }
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+        }
+        if (blockPos.y() < 0 || blockPos.y() >= world.getHeightBlocks()) {
+            return false;
+        }
+        if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
+            if (world.setBlockIdNotify(blockPos, this.blockToPlace.id())) {
+                if (player == null) {
                     this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
-				} else {
+                } else {
                     this.blockToPlace.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-				}
-				if (this.blockToPlace.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
-					TileEntity tileEntity = world.getTileEntity(blockPos);
-					if (tileEntity != null) {
-						tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
-					}
-				}
-				world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
-				return true;
-			}
-		}
-		return false;
-	}
+                }
+                if (this.blockToPlace.isEntityTile && selfStack.getData().containsKey("tileEntityData")) {
+                    TileEntity tileEntity = world.getTileEntity(blockPos);
+                    if (tileEntity != null) {
+                        tileEntity.readAdditionalData(selfStack.getData().getCompound("tileEntityData"));
+                    }
+                }
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
+                return true;
+            }
+        }
+        return false;
+    }
 
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		blockPos = blockPos.add(direction);
-		Block<?> b = world.getBlock(blockPos);
-		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
-			onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
-		}
-	}
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        Block<?> b = world.getBlock(blockPos);
+        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b)) {
+            onUseOnBlock(selfStack, world, null, blockPos, direction.getSide(), 0.5, 0.5);
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
index ec986bc8f..083e383ca 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemRope.java
@@ -7,6 +7,7 @@ import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -16,22 +17,23 @@ public class ItemRope extends ItemPlaceable {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-        if(selfStack.stackSize <= 0) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (selfStack.stackSize <= 0) {
             return false;
         }
+        TilePos bp = new TilePos(blockPos);
         boolean placeOnSide = true;
-        if (world.getBlock(blockPos) == this.blockToPlace && player != null && !player.isSneaking()){
+        if (world.getBlock(bp) == this.blockToPlace && player != null && !player.isSneaking()) {
             placeOnSide = false;
-            TilePos tempPos = new TilePos(blockPos);
-            int _y = blockPos.y;
-            while (_y > 0){
+            TilePos tempPos = new TilePos(bp);
+            int _y = bp.y;
+            while (_y > 0) {
                 _y--;
-                if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), tempPos.set(blockPos.x, _y, blockPos.z), false, side)){
-                    blockPos.y = _y;
+                if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), tempPos.set(bp.x, _y, bp.z), false, side)) {
+                    bp.y = _y;
                     break;
-                } else if (world.getBlock(tempPos.sub(blockPos.x, _y, blockPos.z)) != this.blockToPlace) {
-                    if(side == Side.TOP) {
+                } else if (world.getBlock(tempPos.sub(bp.x, _y, bp.z, new TilePos())) != this.blockToPlace) {
+                    if (side == Side.TOP) {
                         break;
                     }
                     return true;
@@ -39,20 +41,20 @@ public class ItemRope extends ItemPlaceable {
             }
 
         }
-        if(!world.canPlaceInsideBlock(blockPos)) {
-            blockPos = blockPos.add(side.getDirection());
+        if (!world.canPlaceInsideBlock(bp)) {
+            bp = bp.add(side.getDirection(), new TilePos());
         }
-        if(blockPos.y < 0 || blockPos.y >= world.getHeightBlocks()) {
+        if (bp.y < 0 || bp.y >= world.getHeightBlocks()) {
             return false;
         }
-        if(world.canBlockIdBePlacedAt(this.blockToPlace.id(), blockPos, false, side) && selfStack.consumeItem(player)) {
-            if(world.setBlockIdDataNotify(blockPos, this.blockToPlace.id(), placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
+        if (world.canBlockIdBePlacedAt(this.blockToPlace.id(), bp, false, side) && selfStack.consumeItem(player)) {
+            if (world.setBlockIdDataNotify(bp, this.blockToPlace.id(), placeOnSide ? BlockLogicRope.MASK_ROPE_CONNECT : 0)) {
                 if (player == null) {
-                    this.blockToPlace.onPlacedOnSide(world, blockPos, side, xHit, yHit);
+                    this.blockToPlace.onPlacedOnSide(world, bp, side, xHit, yHit);
                 } else {
-                    this.blockToPlace.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
+                    this.blockToPlace.onPlacedByMob(world, bp, side, player, xHit, yHit);
                 }
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, bp.x + 0.5F, bp.y + 0.5F, bp.z + 0.5F, this.blockToPlace, EnumBlockSoundEffectType.PLACE);
                 return true;
             }
         }
